/// <reference types="vitest" />
import { defineConfig } from "vite"

import viteTsConfigPaths from "vite-tsconfig-paths"

export default defineConfig({
	cacheDir: "../../node_modules/.vite/player-web-test",

	server: {
		port: 4200,
		host: "localhost"
	},

	preview: {
		port: 4300,
		host: "localhost"
	},

	plugins: [
		viteTsConfigPaths({
			root: "../../"
		})
	],

	// Uncomment this if you are using workers.
	// worker: {
	//  plugins: [
	//    viteTsConfigPaths({
	//      root: '../../',
	//    }),
	//  ],
	// },

	test: {
		globals: true,
		cache: {
			dir: "../../node_modules/.vitest"
		},
		environment: "jsdom",
		include: ["src/**/*.{test,spec}.{js,mjs,cjs,ts,mts,cts,jsx,tsx}"]
	}
})
